module probability_distributions
implicit none

contains
  !Uniform distribution
  subroutine uniform(N,xlow,rand)
    integer, intent(in) :: N
    real*8, intent(in) :: xlow
    real*8, dimension(N) :: rand
    !Internal variables
    integer :: i

    do i = 1,N
       rand(i) = (1d0 - xlow)*rand(i) + xlow
    enddo
  end subroutine uniform

  !Exponential distribution
  subroutine exponential(N,xlow,rand)
    integer, intent(in) :: N
    real*8, intent(in) :: xlow
    real*8, dimension(N) :: rand
    !Internal variables
    integer :: i

    do i = 1,N
       rand(i) = xlow - LOG(1d0-rand(i))
    enddo
  end subroutine exponential
end module probability_distributions
