program main
use simulations
use omp_lib
implicit none

integer :: N, samples
integer :: seed = 20
real*8 :: limit = 45d4
real*8 :: xlow
real*8, dimension(:,:), allocatable :: rand

call omp_set_num_threads(2)
call init_seed(seed,limit)

N = 100
allocate(rand(N,N))
do samples = 1,135000
   call random_number(rand)
enddo
deallocate(rand)
samples = 15000
xlow = 0d0

call lls_sim_uniform(N,samples,xlow, &
     'x_lls_unif_xlow-0_N100_l45d4_s135001-150000.dat', &
     'excl_lls_unif_xlow-0_N100_l45d4_s135001-150000.dat', &
     'incl_lls_unif_xlow-0_N100_l45d4_s135001-150000.dat')

end program main
