module probability_distributions
implicit none

contains
  !Uniform distribution
  subroutine uniform(N,xlow,rand)
    integer, intent(in) :: N
    real*8, intent(in) :: xlow
    real*8, dimension(N,N) :: rand
    !Internal variables
    integer :: i, j

    do j = 1,N
       do i = 1,N
         rand(i,j) = (1d0-xlow)*rand(i,j) + xlow 
       enddo
    enddo
  end subroutine uniform

  !Exponential distribution
  subroutine exponential(N,xlow,rand)
    integer, intent(in) :: N
    real*8, intent(in) :: xlow
    real*8, dimension(N,N) :: rand
    !Internal variables
    integer :: i, j

    do j = 1,N
       do i = 1,N
          rand(i,j) = xlow - LOG(1d0-rand(i,j))
       enddo
    enddo
  end subroutine exponential
end module probability_distributions
