module probability_distributions
implicit none

contains
  !Uniform distribution
  subroutine uniform(N,xlow,rand)
    integer, intent(in) :: N
    real*8, intent(in) :: xlow
    real*8, dimension(N,N,N,N,N) :: rand
    !Internal variables
    integer :: i, j, k, l, m

    do m = 1,N
    do l = 1,N
       do k = 1,N
          do j = 1,N
             do i = 1,N
                rand(i,j,k,l,m) = (1d0-xlow)*rand(i,j,k,l,m) + xlow
             enddo
          enddo
       enddo
    enddo
    enddo
  end subroutine uniform

  !Exponential distribution
  subroutine exponential(N,xlow,rand)
    integer, intent(in) :: N
    real*8, intent(in) :: xlow
    real*8, dimension(N,N,N,N,N) :: rand
    !Internal variables
    integer :: i, j, k, l, m

    do m = 1,N
    do l = 1,N
       do k = 1,N
          do j = 1,N
             do i = 1,N
                rand(i,j,k,l,m) = xlow - LOG(1d0-rand(i,j,k,l,m))
             enddo
          enddo
       enddo
    enddo
    enddo
  end subroutine exponential

end module probability_distributions
